Search for inventory hard reservations - Fabric

Search for inventory hard reservations

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/inventories/actions/hard-reserve-search \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "filters": [
    {
      "condition": "EQ",
      "field": "hardReserve.allocationRequestId",
      "value": "123"
    },
    {
      "condition": "IN",
      "field": "hardReserve.inventoryAllocations.channelId",
      "values": [
        "WHBM",
        "CHO"
      ]
    }
  ],
  "sort": "-hardReserve.createdAt"
}'

Python

import requests

url = "https://api.fabric.inc/v3/inventories/actions/hard-reserve-search"

payload = {
    "filters": [
        {
            "condition": "EQ",
            "field": "hardReserve.allocationRequestId",
            "value": "123"
        },
        {
            "condition": "IN",
            "field": "hardReserve.inventoryAllocations.channelId",
            "values": ["WHBM", "CHO"]
        }
    ],
    "sort": "-hardReserve.createdAt"
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    filters: [
      {condition: 'EQ', field: 'hardReserve.allocationRequestId', value: '123'},
      {
        condition: 'IN',
        field: 'hardReserve.inventoryAllocations.channelId',
        values: ['WHBM', 'CHO']
      }
    ],
    sort: '-hardReserve.createdAt'
  })
};

fetch('https://api.fabric.inc/v3/inventories/actions/hard-reserve-search', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/inventories/actions/hard-reserve-search",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'filters' => [
        [
                'condition' => 'EQ',
                'field' => 'hardReserve.allocationRequestId',
                'value' => '123'
        ],
        [
                'condition' => 'IN',
                'field' => 'hardReserve.inventoryAllocations.channelId',
                'values' => [
                                'WHBM',
                                'CHO'
                ]
        ]
    ],
    'sort' => '-hardReserve.createdAt'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/inventories/actions/hard-reserve-search"

payload := strings.NewReader("{\n  \"filters\": [\n    {\n      \"condition\": \"EQ\",\n      \"field\": \"hardReserve.allocationRequestId\",\n      \"value\": \"123\"\n    },\n    {\n      \"condition\": \"IN\",\n      \"field\": \"hardReserve.inventoryAllocations.channelId\",\n      \"values\": [\n        \"WHBM\",\n        \"CHO\"\n      ]\n    }\n  ],\n  \"sort\": \"-hardReserve.createdAt\"}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Errors

Example Responses

Success Response

{
  "data": [
    {
      "createdAt": "2022-08-01T18:03:28.483Z",
      "importId": "62ff5c0bec0aed3c86202c32",
      "attributes": {
        "attribute": "12345"
      },
      "errorFileUrl": "https://example.com/tenant/import/bulk/1654680575676.csv?X-Amz-Security-Token=IQoJb3JpZ2",
      "fileName": "orderUpload.csv",
      "finishedAt": "2022-08-01T18:03:28.483Z",
      "importCount": {
        "error": 2000,
        "processed": 8000,
        "uploaded": 10000
      },
      "originalFileUrl": "https://example.com/tenant/import/bulk/1654680575676.csv?X-Amz-Security-Token=IQoJb3JpZ2",
      "statusCode": "INITIATED",
      "type": "INVENTORY",
      "updatedAt": "2022-08-01T20:03:28.483Z"
    }
  ],
  "pagination": {
    "count": 1000,
    "limit": 10,
    "offset": 1
  }
}

Error Response

{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}
{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}
{
  "message": "Internal server error",
  "type": "SERVER_ERROR"
}

Authorization Headers

Body Parameters